#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <cxcore.h>
#include <cv.h>
#include <highgui.h>
#include <math.h>

#define CENTER_X 320
#define IMG_X 640
#define IMG_Y 480

#define DIST_GAIN 1

#define __DEBUG__

void get_img(char *str,int width,int height,char *device);
int color_detect(char *DeviceNum);
int labelling(IplImage *src, CvRect *rect);

//*****テスト用main*****
int main(void){
	int i=0;
	printf("Choose device{front:0 or back:1}\n");
	scanf("%d",&i);
	switch(i){
		case 0:i=color_detect("/dev/video0");
			break;
		case 1:i=color_detect("/dev/video1");
			break;
		default:printf("ERROR");
	}
	printf("color_detect return value\t%d\n",i);
	return 0;
}

void get_img(char *str,int width,int height,char *device){
	int cap;
	char command[100];
	//sprintf(command,"uvccapture -o%s -x%d -y%d\n",str,width,height);
	sprintf(command,"uvccapture -o%s -x%d -y%d -d%s\n",str,width,height,device);
	cap=system(command);
	usleep(10*1000);
	if(cap!=0){
		printf("Capture fail!!\n");
	}
}

int color_detect(char *DeviceNumber,int *ret){
//*****変数定義*****
	int caperr = 0;
	//int i;
	//int xy1[4], xy2[4];
	IplImage *input = 0;
	IplImage *mask = 0;
	IplImage *smooth = 0;
	CvRect rect;
	rect.x=0;
	rect.y=0;
	rect.width=0;
	rect.height=0;
	CvSize cvsize;

	int count = 0;
	int num_1=-1,  num_2=-1;
	int x0_1=0, x0_2=0;
	int number = - 1;
	int CenterX,CenterY;	//風船の中心座標
	int Angle,Areasquare;	//風船までの距離とその角度、風船を検出したエリア(四角)の面積
	double Distance,Rad;
	char DevNum[100];

//*****画像取得*****
	get_img("./../img/input.jpg", IMG_X, IMG_Y,DeviceNumber);
	if(caperr != 0){	 //キャプチャが失敗したときの例外処理
		return -1;
	}
	input = cvLoadImage("./../img/input.jpg", CV_LOAD_IMAGE_ANYCOLOR);

//	cvNamedWindow("input", CV_WINDOW_AUTOSIZE);
//	cvShowImage("input", input);
//	cvWaitKey(0);

//*****色検出******
//	cv_ColorExtraction(input,"./../img/mask.jpg",CV_BGR2HSV,170,10,80,255,0,255);
	cv_ColorExtraction(input,"./../img/mask.jpg",CV_BGR2HSV,170,10,100,255,60,255);
	mask=cvLoadImage("./../img/mask.jpg",CV_LOAD_IMAGE_ANYCOLOR);

//	smooth = cvCreateImage(cvGetSize(src), IPL_DEPTH_8U,1);
//*****平滑化*****
	smooth = cvCreateImage(cvGetSize(mask), IPL_DEPTH_8U,1);
	cvSmooth(mask,smooth,CV_MEDIAN,9,9,0,0);
	cvSaveImage("./../img/smooth.jpg",smooth,NULL);

//*****ラベリング*****
	int num;
	int xy[10][4];

	num = labelling(smooth,&rect);

#ifdef __DEBUG__
	printf("Number of Triming area = %d\n",num);
	printf("x\t%d\ty\t%d\twidth\t%d\theight\t%d\n",rect.x,rect.y,rect.width,rect.height);
#endif

//*****中心座標算出*****
	CenterX = rect.x + rect.width/2;
	CenterY = rect.y + rect.height/2;
#ifdef __DEBUG__
	printf("CenterPoint(%d,%d)\n",CenterX,CenterY);	//左上が原点0
#endif

//*****面積算出*****
	Areasquare = rect.width*rect.height;
#ifdef __DEBUG__
	printf("Areasquare\t%d\n",Areasquare);
#endif

//*****方向算出*****	カメラのデバイス番号をMIRS本体で固定する必要あり。
//1	Distance = Areasquare*0.01;				//数値はゲインのため適宜変更、尚算出方式は適当である。
	Distance = 150*(sqrt(12000))/(sqrt(Areasquare));
//	Distance = 150*(sqrt(12480))/(sqrt(Areasquare));	//基準の距離*(sqrt(基準の面積))/(sqrt(画像での面積))

#ifdef __DEBUG__
printf("Distance\t%f\tCenterX\t%d\n",Distance,CenterX);
#endif
	Angle = 0;
	Rad = 0;
	if(DeviceNumber == "/dev/video1"){
//1		Angle = (CenterX-320)*3/32;			//Angleは現在の正面からの相対角度[deg]
		Rad = atan(((CenterX-CENTER_X)/(Distance*DIST_GAIN)));	//CenterXはPixelで、Distanceはcmなので単位を合わせる必要あり。
		Angle = Rad*(180/M_PI);
	}else if(DeviceNumber == "/dev/video0"){
printf("video1");
//1		Angle = (320-CenterX)*3/32+180;
		Rad = tan((double)(CENTER_X-CenterX)/Distance*10);
		Angle = Rad*(180/M_PI);
		if(Angle>180)Angle=Angle-360;
		else if(Angle<-180)Angle=Angle+360;
	}else{
		printf("Baloon Not Found");
	}
	printf("Angle\t%d\n",Angle);

	int Flag=Distance;
	if(Flag >= 500){
		return -1;
	}else if(Flag <= 0){
		return -1;
	}else return Angle;
}
