#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <cxcore.h>
#include <cv.h>
#include <highgui.h>
#include <math.h>

#include "Extern.h"
#include "../Number/Extern.h"

#define IMG_X 320
#define IMG_Y 240
#define BALOONAREA 500		//風船の最小面積

#define __DEBUG__

/*
次の値を適宜変更する。
BALOONAREA:検出した面積が小さい場合、風船としない。風船とする最小の面積をBALLONAREAとする。
色検出にあるcv_ColorExtractionのHSVの値。体育館では環境が異なるため要変更。

*/

int color_detect(char *DeviceNumber,int *ret){
//*****変数定義*****
	int caperr = 0;
	//int i;
	//int xy1[4], xy2[4];
	IplImage *input = 0;
	IplImage *mask = 0;
	IplImage *smooth = 0;
	CvRect rect;
	rect.x=0;
	rect.y=0;
	rect.width=0;
	rect.height=0;
	CvSize cvsize;

	int count = 0;
	int num_1=-1,  num_2=-1;
	int x0_1=0, x0_2=0;
	int number = - 1;
	int CenterX,CenterY;	//風船の中心座標
	int Distance,Angle,areasquare;	//風船までの距離とその角度、風船を検出したエリア(四角)の面積
	char DevNum[100];
	int dev;

//*****画像取得*****
	get_img("./img/input.jpg", IMG_X, IMG_Y,DeviceNumber);
	if(caperr != 0){	 //キャプチャが失敗したときの例外処理
		return -1;
	}
	input = cvLoadImage("./img/input.jpg", CV_LOAD_IMAGE_ANYCOLOR);

//	cvNamedWindow("input", CV_WINDOW_AUTOSIZE);
//	cvShowImage("input", input);
//	cvWaitKey(0);

//*****色検出******
//	cv_ColorExtraction(input,"./img/mask.jpg",CV_BGR2HSV,170,10,80,255,0,255);
//	cv_ColorExtraction(input,"./img/mask.jpg",CV_BGR2HSV,170,10,100,255,60,255);				//HSVの範囲、要変更
	cv_ColorExtraction(input,"./img/mask.jpg",CV_BGR2HSV,180,10,61,255,90,255);		//体育館HSV
	mask=cvLoadImage("./img/mask.jpg",CV_LOAD_IMAGE_ANYCOLOR);

//	smooth = cvCreateImage(cvGetSize(src), IPL_DEPTH_8U,1);
//*****平滑化*****
	smooth = cvCreateImage(cvGetSize(mask), IPL_DEPTH_8U,1);
	cvSmooth(mask,smooth,CV_MEDIAN,9,9,0,0);
	cvSaveImage("./img/smooth.jpg",smooth,NULL);

//*****ラベリング*****
	int num;
	int xy[10][4];

	num = labelling2(smooth,&rect);

#ifdef __DEBUG__
	printf("Triming area value = %d\n",num);
	printf("x\t%d\ty\t%d\twidth\t%d\theight\t%d\n",rect.x,rect.y,rect.width,rect.height);
#endif

//*****中心座標算出*****
	CenterX = rect.x + rect.width/2;
	CenterY = rect.y + rect.height/2;
#ifdef __DEBUG__
	printf("CenterPoint(%d,%d)\n",CenterX,CenterY);	//左上が原点0
#endif

//*****面積算出*****
	areasquare = rect.width*rect.height;
#ifdef __DEBUG__
	printf("areasquare\t%d\n",areasquare);
#endif

	if(areasquare <= BALOONAREA || areasquare > 76800){
		ret[0]=-1;
		ret[1]=0;
		ret[2]=0;
		return -1;
	}

//*****方向算出*****	カメラのデバイス番号をMIRS本体で固定する必要あり。
//1	Distance = areasquare*0.01;				//数値はゲインのため適宜変更、尚算出方式は適当である。
	Distance = 150*(sqrt(3120))/(sqrt(areasquare));	//基準の距離*(sqrt(基準の面積))/(sqrt(画像での面積))150:12480
#ifdef __DEBUG__
printf("Distance\t%d\tCenterX\t%d\n",Distance,CenterX);
#endif
	Angle = 0;
	double ang;
	if(DeviceNumber == "/dev/video1"){
//1		Angle = (CenterX-(IMG_X/2))*3/32;			//Angleは現在の正面からの相対角度[deg]
		ang = (atan((double)((double)CenterX-(double)(IMG_X/2))/(double)(Distance*20)));	//CenterXはPixelで、Distanceはcmなので単位を合わせる必要あり。
		dev = 0;
	}else if(DeviceNumber == "/dev/video0"){
//1		Angle = (320-CenterX)*3/32+180;
//		if(Angle>180)Angle=Angle-360;
//		else if(Angle<-180)Angle=Angle+360;
		ang = (atan((double)((double)CenterX-(double)(IMG_X/2))/(double)(Distance*20)));
		dev = 1;
	}else{
		printf("デバイス不明");
	}
	Angle = ang*(360/M_PI);

//	if()

	ret[0]=dev;
	ret[1]=Distance;
	ret[2]=Angle;

//	cvReleaseImage(&smooth);

	return 1;
}
