#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <cxcore.h>
#include <cv.h>
#include <highgui.h>
#include "define.h"

#define __DEBUG__

int labelling(IplImage *src, int pxy[10][4], int dist){

	int label_num=0;
	int cntr_num;
	int i, j;
	//int area_num ;
	int x1[100], y1[100], x2[100], y2[100], width[100], height[100];
	int xy_h[4];
	//double Area;
	//IplImage *dst;
	CvMemStorage *storage = cvCreateMemStorage(0);
	CvSeq *contour = NULL;
	CvRect rect[100];
	//CvPoint point1[100], point2[100];
	IplImage *src2;

	//src2= cvCreateImage(cvGetSize(src), IPL_DEPTH_8U, src->nChannels);
	src2= cvCreateImage(cvGetSize(src), IPL_DEPTH_8U, 1);
	cvCopyImage(src, src2);

	label_num = 0;

	//int xt1_1 = 0, yt1_1 = 0, xt2_1 = 0, yt2_1 = 0;
	//int xt1_2 = 0, yt1_2 = 0, xt2_2 = 0, yt2_2 = 0;

	for(i=0;i<10;i++){
		for(j=0;j<4;j++){
			pxy[i][j] = -1;
		}
	}

	// エリアの抽出条件
	/* 320x240 pixel の画像を50cm の距離で撮影した場合
	   1以外の数字   width = 60 ,  height = 106 
	   1の場合       widht = 13 ,  height = 106 
	   widht_min = 10, widht_max = 80, height_min = 90, height_min = 120
	*/

	int width_min, width_max, height_min, height_max;
	float mag ; // 320x240pixel, 50cm を基準とした、拡大（縮小）率

//	mag = 1.* 50./(float)dist;
	mag = 1;
	//mag = 2 * 50. /150. ; 640x480pixel, 150cm の場合

	// 数字の1 を認識できるに、wight_min を小さい値としている。
	// 1がない場合はより大きくした方が誤認識がなくなる。
	width_min = 10*mag; width_max =80*mag; 
	height_min = 90*mag; height_max =120*mag; 
	printf("width_min=%d, width_max=%d, height_min=%d, height_max=%d\n", width_min, width_max, height_min, height_max);


	if(src == NULL) return -1;
	cntr_num = cvFindContours(src, storage, &contour, sizeof(CvContour), CV_RETR_LIST, CV_CHAIN_APPROX_SIMPLE, cvPoint(0,0));//輪郭検出(戻り値は取得した輪郭の全個数)
	#ifdef __DEBUG__
		printf("抽出した輪郭の個数=%d\n",cntr_num);
	#endif
		for(i = 0; i < cntr_num; i++){
		x1[i] = 1;
		y1[i] = 1;
		x2[i] = 1;
		y2[i] = 1;
		height[i] = 0;
		width[i] = 0;
	}

	for(i = 0; i < cntr_num; i++){	//輪郭の傾いていない外接四角形領域の座標を取得
		rect[i] = cvBoundingRect(contour, 1);
		x1[i] = rect[i].x;
		y1[i] = rect[i].y;
		x2[i] = rect[i].x + rect[i].width;
		y2[i] = rect[i].y + rect[i].height;
		height[i] = rect[i].height;
		width[i] = rect[i].width;
	#ifdef __DEBUG__
		printf("エリア番号=%d   エリアの幅=%d    エリアの高さ=%d\n",i,width[i],height[i]);
	#endif
		cvRectangle(src2, cvPoint(x1[i], y1[i]), cvPoint(x2[i], y2[i]), CV_RGB(255, 255, 255), 1, 8, 0);

	// エリアの抽出条件
		if(width[i] > width_min && width[i] < width_max && height[i] > height_min && height[i] < height_max){  

			cvRectangle(src, cvPoint(x1[i], y1[i]), cvPoint(x2[i], y2[i]), CV_RGB(255, 255, 255), 1, 8, 0);
			xy_h[0] = x1[i], xy_h[1] = y1[i], xy_h[2] = x2[i], xy_h[3] = y2[i];
			for(j=0;j<4;j++){
				pxy[label_num][j] = xy_h[j];
			}
			label_num++;
	#ifdef __DEBUG__
				printf("エリア番号=%d   ラベル番号=%d\n",i,label_num);
	#endif
		}

		contour = contour->h_next;
	}

	cvSaveImage("./img/label-all.jpg", src2, NULL);
	cvSaveImage("./img/label.jpg", src, NULL);

//メモリストレージの解放
//	cvReleaseMemStorage (&storage);
//	cvReleaseImage(&dst);

	return label_num;
}

