/*
モータを動作させるモジュール
・制御指令値を PWM値に変換し、左右のモータを駆動する。
2014/07/14  by S.Ushimaru
*/

#include <linux/errno.h>
#include <sys/io.h>
#include <unistd.h>
#include <math.h>
#include <time.h>
#include <pthread.h>
#include <stdio.h>

#include "device.h"
#include "motor.h"
#include "math.h"

void motor_drive(int u_l, int u_r ){

	int output_duty_r, output_duty_l;        //Duty比にしたもの
	int final_output_r, final_output_l;      //最終的に書きこむ値

	int ret_val;
        unsigned char m_data[2];

	int fd_motor;
	fd_motor=device_motor_get();

        output_duty_r = u_r;
        output_duty_l = u_l;
        //printf("duty_r=%d  dutry_l=%d\n", output_duty_r, output_duty_l);

        //PWM不感帯を補正する
        if(output_duty_r > 0){
                output_duty_r = output_duty_r + R_SHIFT_B;
        }else if(output_duty_r < 0){
                output_duty_r = output_duty_r - R_SHIFT_F;
        }else{output_duty_r=0;}

        if(output_duty_l > 0){
                output_duty_l = output_duty_l + L_SHIFT_F;
        }else if(output_duty_l < 0){
                output_duty_l = output_duty_l - L_SHIFT_B;
        }else{output_duty_l=0;}


        //入力飽和
        output_duty_r = (output_duty_r > 110) ? 110 : output_duty_r;
        output_duty_r = (output_duty_r < -110) ? -110 : output_duty_r;
        output_duty_l = (output_duty_l > 110) ? 110 : output_duty_l;
        output_duty_l = (output_duty_l < -110) ? -110 : output_duty_l;

        float right_vdata, left_vdata;
        right_vdata = fabs(output_duty_r) ;
        final_output_r = (output_duty_r >= 0) ? right_vdata + 128 : right_vdata;
        left_vdata = fabs(output_duty_l) ;
        final_output_l = (output_duty_l < 0) ? left_vdata + 128 : left_vdata;

        m_data[0]=final_output_l;
        m_data[1]=final_output_r;
        ret_val=write(fd_motor,m_data,2);

}

