//全体の制御を行う
//main
#include <stdio.h>
#include <linux/errno.h>
#include <unistd.h>
#include <pthread.h>
#include <math.h>
#include <sys/io.h>

#include "mirsak.h"
#include "device.h"
#include "direction.h"
#include "encoder.h"
#include "vel_ctrl.h"

int main(){

	int ret_val;

	//デバイスオープン
	ret_val=device_encoder_open();
	ret_val=device_motor_open();
	ret_val=device_uss_open();
	ret_val=device_io_open();

	//エンコーダ、速度制御スレッドの生成
	encoder_create(); 
        vel_ctrl_create();

	mirsak_patrol(); //巡回走行
	//mirsac_chase(); //追跡（未実装）

	//デバイスのクローズ
	ret_val=device_encoder_close();
	ret_val=device_motor_close();
	ret_val=device_uss_close();

	return 0;

}

