/*
巡回一つ目の宝を確保する。
*/

//test_run_ctrl.cを元にして作成
//シーケンスの走行の部分を作成した。
//統合の仕方が分からないので、ここに正対補正などのプログラムを追加する。
#include <stdio.h>
#include <linux/errno.h>
#include <unistd.h>
#include <pthread.h>
#include <sys/io.h>
#include "device.h"
#include "hardware.h"
#include "encoder.h"
#include "vel_ctrl.h"
#include "distance.h"
#include "run_ctrl.h"
#include "direction.h"	//追加
#include "number.h"	//追加
#include "io.h"		//追加
#include "uss.h"	//追加
#include "vel_ctrl.h"	//追加
#include "../Server/server_info.h"//追加





#define s_speed 45
#define r_speed 20

static char mode;
static pthread_t tasks[1];
static int run_dist, rot_angle;


void f_straight (int sspeed,int disr);
void f_rotate (int rspeed,int angle);
void cameta_first(int kyori);
int numbers[2];		//何となく
int number = 0;		//初期値

static void *thread_code(void *t){

	int counter=0;
	struct distance_data distance_data;
	float speed_l, speed_r;

	while(1){
		counter++;
		vel_ctrl_get_speed(&speed_l, &speed_r);
		distance_get(&distance_data);
		printf("speed_l=%5.1f   speed_r=%5.1f     dis_left=%6.1f    dis_right=%6.1f\n",speed_l, speed_r, distance_data.left, distance_data.right);

		usleep((T_TEST-1)*1000); // 実行周期

	}

	usleep(200000);
	distance_get(&distance_data);
	printf("dis_left=%6.1f    dis_right=%6.1f\n",distance_data.left, distance_data.right);

	return 0;

}

static int thread_create()
{
	pthread_attr_t attr;
	struct sched_param sched_param;
	int ret;

	pthread_attr_init(&attr);
	sched_param.sched_priority = 5;
	pthread_attr_setschedparam(&attr, &sched_param);
	ret = pthread_create(&tasks[0], &attr, thread_code, (void *)2);

	return 0;
}




void firstcheck(){

	int s_val;
	char dumy;

	while(1){


		printf("check1 start!!");
		f_rotate (r_speed, 90-3);
		f_straight (s_speed, 100);
		direction_correct(64);			
		f_rotate(-1*r_speed, -45);
		f_straight (s_speed, 110);
		f_rotate (r_speed, 45);
		direction_correct(14);		
		f_rotate (r_speed, 90);
		direction_correct(64);
		camera_first(64);//数字認識
		server_info_treasure(number);//サーバーに宝番号を送信する。
		f_rotate (r_speed, 45);
		f_straight (s_speed, 125);
		f_rotate (-1*r_speed, -45);
		direction_correct(18);
		f_rotate (r_speed, 90-5);
		f_straight (30, 115);
		direction_correct(63);
		f_rotate (r_speed, 90);
		f_straight (30, 200);
		direction_correct(213);			//真ん中に行きたい。
		
		sequence_flag = 0;

		printf("finish");
		pthread_cancel(tasks[0]);

	}

	printf("thread_id=%d\n",(int)tasks[0]);

	pthread_join(tasks[0],NULL);

	printf("finish\n");

}

void camera_first(int kyori){
	int count =1;
	number_set_nums(1);	//ボード上の数字の数をセット
	while(number !=2 && number != 4 && number !=6 && number !=8){
		printf("camera try %d",count);
		number_detect(kyori);	//ボード上の数字を認識する
		number_get(numbers);

		number = numbers[0];
		if (number== 1) number=8;
		count++;
	        printf("認識した数字=%d\n",numbers[0]);	//認識した数字を取得する
		if(count==6)break;

	}

}



void f_straight(int sspeed,int dist){

		printf("straight_____speed%d\n",sspeed);
		run_ctrl_set(STRAIGHT, (float)sspeed);
		run_ctrl_set_dist((float)dist);
		run_ctrl_create();
		while(1){
		
		if(run_ctrl_get_endflag()==1) break;
			usleep(20000);
		}		
		run_ctrl_cancel();
		//0.3秒待機
		usleep(300000);
}

void f_rotate(int rspeed,int angle){

		printf("rotate_____speed%d\n",rspeed);
		run_ctrl_set(ROTATE, (float)rspeed);
		run_ctrl_set_dist((float)angle);

		run_ctrl_create();
		while(1){
		if(run_ctrl_get_endflag()==1) break;
			usleep(20000);		
		}
		run_ctrl_cancel();
		//0.3秒待機
		usleep(300000);
}

