/*
速度制御	2014/7/3
*/
#include <stdio.h>
#include <linux/errno.h>
#include <unistd.h>
#include <pthread.h>
#include <sys/io.h>
#include "device.h"
#include "hardware.h"
#include "encoder.h"
#include "vel_ctrl.h"
#include "distance.h"
#include "run_ctrl.h"

static char mode;
static pthread_t tasks[1];
static int run_dist, rot_angle;

static void *thread_code(void *t){

	int counter=0;
	struct distance_data distance_data;
	float speed_l, speed_r;

	while(1){
		counter++;

		vel_ctrl_get_speed(&speed_l, &speed_r);
		distance_get(&distance_data);
		//printf("dis_left=%6.1f    dis_right=%6.1f\n",distance_data.left, distance_data.right);
		printf("speed_l=%5.1f   speed_r=%5.1f     dis_left=%6.1f    dis_right=%6.1f\n",speed_l, speed_r, distance_data.left, distance_data.right);

		usleep((T_TEST-1)*1000); // 実行周期

	}

	//run_ctrl_cancel();
	//vel_ctrl_set(0., 0.);

	usleep(200000);
	distance_get(&distance_data);
	printf("dis_left=%6.1f    dis_right=%6.1f\n",distance_data.left, distance_data.right);

	return 0;

}

static int thread_create()
{
	pthread_attr_t attr;
	struct sched_param sched_param;
	int ret;

	pthread_attr_init(&attr);
	sched_param.sched_priority = 5;
	pthread_attr_setschedparam(&attr, &sched_param);
	ret = pthread_create(&tasks[0], &attr, thread_code, (void *)2);

	return 0;
}

void test_run_ctrl(){

	int s_val;
	int speed;
	char dumy;

	//vel_ctrl_reset();

	encoder_create();
	vel_ctrl_create();



	while(1){

		printf("run mode (s or r) = ");
		s_val=scanf("%c",&mode);
		s_val=scanf("%c",&dumy); //改行コードを読み飛ばす

		if(mode=='s'){
			printf("speed value [cm/s]= ");
			s_val=scanf("%d",&speed);
			s_val=scanf("%c",&dumy); //改行コードを読み飛ばす
			printf("distance [cm]= ");
			s_val=scanf("%d",&run_dist);
			s_val=scanf("%c",&dumy); //改行コードを読み飛ばす
			run_ctrl_set(STRAIGHT, (float)speed);
			run_ctrl_set_dist((float)run_dist);

		}else if(mode=='r'){
			printf("rataiton speed [deg/s]= ");
			s_val=scanf("%d",&speed);
			s_val=scanf("%c",&dumy); //改行コードを読み飛ばす
			printf("rataiton angle [deg]= ");
			s_val=scanf("%d",&rot_angle);
			s_val=scanf("%c",&dumy); //改行コードを読み飛ばす
			run_ctrl_set(ROTATE, (float)speed);
			run_ctrl_set_dist((float)rot_angle);

		}

		run_ctrl_create();
		thread_create();

		while(1){
			//printf("ctrl dist loop\n");
			if(run_ctrl_get_endflag()==1){
				//printf("get endflag!!!!\n");
				//run_ctrl_reset();
				//run_ctrl_stop();
				//distance_reset();
				break;
			}
			usleep(20000);
		}

		pthread_cancel(tasks[0]);

	}

	run_ctrl_cancel();
	printf("thread_id=%d\n",(int)tasks[0]);

	pthread_join(tasks[0],NULL);
	//vel_ctrl_set((float)vel_l_ref, (float)vel_r_ref); 
	//run_ctrl_create(STRAIGHT);

	printf("Program stopped\n");

}


