//統合プログラム pilot.cを変更

#include <stdio.h>
#include <linux/errno.h>
#include <unistd.h>
#include <pthread.h>
#include <math.h>
#include <sys/io.h>

#include "Run/direction.h"
#include "Run/encoder.h"
#include "Run/vel_ctrl.h"
#include "Run/device.h"
#include "Sequence/Extern.h"
#include "Chase/Extern.h"

extern void firstcheck();

int main(void){
	int ret_val;
	int i;

	//音楽再生
//	system("aplay electrical.wav");
//	system("amixer sset Master off");
//	system("amixer sset Master 100%");


	//デバイスオープン
	ret_val=device_encoder_open();
	ret_val=device_motor_open();
	ret_val=device_uss_open();
	ret_val=device_io_open();

	//エンコーダ、速度制御スレッドの生成
	encoder_create(); 
        vel_ctrl_create();

	firstcheck(); //巡回走行
	Chase(); //追跡

	//デバイスのクローズ
	ret_val=device_encoder_close();
	ret_val=device_motor_close();
	ret_val=device_uss_close();

	return 0;
}

